<%
'
'********************************************************
' My first web calculator
'
' Author     : Elario Belmontes, Jr.
' Description: Four function calculator simulator for
'              educational purposes to illustrate the 
'              use of a web page on a personal web
'              server
' Languanges : VBSCRIPT, JAVASCRIPT, JQUERY, HTML, CSS
' File Name  : calc_42.asp
' Disclaimer: This software is intended for educational learning
'             purposes.
'
'             This software is provided "AS IS" and without any
'             expressed or implied warranties, including, without
'             limitation, the implied warranties of merchantability
'             and fitness for a particular purpose.
'
'             No guarantee; No warranty; Install / Use at your own risk.
'
'
' Copyright (C) 2015 Larry Belmontes, Jr. 
'
'
'
'********************************************************
'
'
'********************************************************
' Declare variables
'********************************************************
Option Explicit
'
Dim myScriptName, myTitle, frm_AuditTape, frm_NumIn, frm_Control, frm_AccumTape, ErrMsg, MaxInput
'

'********************************************************
' Get my script file name
'********************************************************
'
myScriptName = Request.ServerVariables("SCRIPT_NAME")
If Instr(myScriptName, "/") > 0 Then 
	myScriptName = Right(myScriptName, Len(myScriptName) - instrRev(myScriptName, "/")) 
End If 
'
'********************************************************
' Process FORM post (i.e. calculator button pressed)
'********************************************************
'
If UCase(Request.ServerVariables("REQUEST_METHOD")) = "POST" Then
	'
	'********************************************************
	' Obtain data from FORM controls 
	'   and initialize variables
	'********************************************************
	'
	myTitle = "myWeb Calculator"
	frm_AuditTape = Trim(Request.Form("AuditTape"))
	frm_NumIn = Trim(Request.Form("NumIn"))
	frm_AccumTape = Trim(Request.Form("AccumTape"))
	ErrMsg = "&nbsp;"
	MaxInput = 12
	'
	'********************************************************
	' Button on FORM pressed -
	'   Process number, function or housekeep button on form
	'
	'   Loop through each FORM field and take appropriate
	'     action from POST data
	'       (i.e.  AuditTape=&AccumTape=&NumIn=&B8=8)
	'********************************************************
	'
	'Response.Write (Request.Form & "<br/>")
	'
	For each frm_Control in Request.Form
		Select Case frm_Control
			'
			'********************************************************
			' Math functions: add, subtract, multiply, divide
			'********************************************************
			Case "Fplus", "Fminus", "Fmult", "Fdiv"
				Call Do_Math
			'
			'********************************************************
			' Terminate Math function: equals
			'********************************************************
			Case "Fequal"
				Call Finalize_Math
			'
			'********************************************************
			' Housekeep: Clear all
			'********************************************************
			Case "Fclear"
				Call Clear_key
			'
			'********************************************************
			' Housekeep: Power Off
			'********************************************************
			Case "Poff"
				Call Power_Off_key
   				Response.End
			'
			'********************************************************
			' Housekeep: Power On
			'********************************************************
			Case "Pon"
   				Call Power_On_key
			'
			'********************************************************
			' Housekeep: Clear entry
			'********************************************************
			Case "Fcleare"
				Call Clear_Entry_key
			'
			'********************************************************
			' Numeric entry
	   		'  Limit to 16 digits entry excluding decimal point
			'********************************************************
   			Case "B0", "B1", "B2", "B3", "B4", "B5", "B6", "B7", "B8", "B9"
		    	Call Numeric_key
			'
			'********************************************************
			' Decimal point entry
			'********************************************************
   			Case "Bdot"
   				Call Decimal_key
		End Select				
	Next
Else
	'
	'********************************************************
	' NOT a POST, initialize session variables 
	'  Assume first time invoked
	'********************************************************
    Session("NumberIn") = ""
    Session("NumberInFunction") = ""
   	myTitle = "Welcome to myCalculator and happy calculating!"
End If


'
'********************************************************
' Subroutines Section
'********************************************************



'
'********************************************************
' Subroutine: Do_Math
' Math functions: add, subtract, multiply, divide
'********************************************************
Sub Do_Math
	'
   	If frm_NumIn > "" Then
   		frm_AccumTape = frm_AccumTape & Session("NumberIn") & Session("NumberInFunction")
    	Call ComputeIT
		frm_AuditTape = frm_AuditTape & frm_NumIN & " " & Request.Form(frm_Control) & " " & vbCrLf
		frm_AccumTape = frm_AccumTape & frm_NumIn & "=" & Session("NumberIn") & " " & vbCrLf
		Session("NumberInFunction") = Request.Form(frm_Control)
		frm_NumIn = ""
	Else
		ErrMsg = "No data entered..."
	End If

End Sub

'
'********************************************************
' Subroutine: Finalize_Math
' Terminate Math function: equals key
'********************************************************
Sub Finalize_Math
'
   	If frm_NumIn > "" Then
   		frm_AccumTape = frm_AccumTape & Session("NumberIn") & Session("NumberInFunction")
    	Call ComputeIT
		frm_AuditTape = frm_AuditTape & frm_NumIN & " " & Request.Form(frm_Control) & " " & vbCrLf
		frm_AuditTape = frm_AuditTape & Session("NumberIn") & " T " & vbCrLf
		frm_AccumTape = frm_AccumTape & frm_NumIn & "=" & Session("NumberIn") & " " & vbCrLf
		frm_AccumTape = frm_AccumTape & "^^^^^^^^^^^^^^^^^^^^^^^ " & vbCrLf
		frm_NumIn = ""
		Session("NumberIn") = ""
		Session("NumberInFunction") = ""
	Else
		ErrMsg = "No data entered..."
	End If

End Sub

'
'********************************************************
' Subroutine: Clear_key
' Housekeep: ClearAll key
'********************************************************
Sub Clear_key
'
	frm_AuditTape = ""
	frm_AccumTape = ""
	frm_NumIn = ""
	Session("NumberIn") = ""
	Session("NumberInFunction") = ""

End Sub

'
'********************************************************
' Subroutine: Power_Off_key
' Housekeep: Power Off key
'********************************************************
Sub Power_Off_key
'
	Session.Contents.Remove("NumberIn")
	Session.Contents.Remove("NumberInFunction")
	Response.Clear
	Response.Write ("Powered Off!<br><br>Click <a title=" & Chr(34) & "Power On Calculator" & Chr(34) & _
   				 " href=" & Chr(34) & myScriptName & Chr(34) & "><font color=" & Chr(34) & "#FFFFFF" & _
   				 "><span style=" & Chr(34) & "background-color: #0000CC" & Chr(34) & ">here</span></font></a>" & _
   				 " to power on calculator...")

End Sub

'
'********************************************************
' Subroutine: Power_On_key
' Housekeep: Power On
'********************************************************
Sub Power_On_key
'
	ErrMsg = "Power already ON..."

End Sub

'
'********************************************************
' Subroutine: Clear_Entry_key
' Housekeep: Clear entry 
'********************************************************
Sub Clear_Entry_key
'
	frm_NumIn = ""

End Sub

'
'********************************************************
' Subroutine: Numeric_key
' Numeric entry
'  Limit to n digits entry based on MaxInput excluding decimal point
'********************************************************
Sub Numeric_key
'
   	If Instr(frm_NumIn,".") = 0 Then
   	    ' no decimal found in number input
   	    '  check for MAXInput - 1
   		If Len(frm_NumIn) > (MaxInput - 1) Then
   			ErrMsg = "Input limited to " & MaxInput & " digits!"
   		Else
    		frm_NumIn = frm_NumIn & Request.Form(frm_Control)
   		End If
   	Else
   		' found decimal point in number input
   		'  check for MAXInput
		If Len(frm_NumIn) > MaxInput Then
			ErrMsg = "Input limited to " & MaxInput & " digits!"
    	Else
    		frm_NumIn = frm_NumIn & Request.Form(frm_Control)
    	End If
   	End If	

End Sub

'
'********************************************************
' Subroutine: Decimal_key
' Decimal point entry
'********************************************************
Sub Decimal_key
'
	If Instr(frm_NumIn,".") = 0 Then
		frm_NumIn = frm_NumIn & "."
	End If

End Sub

'
'********************************************************
' Subroutine: ComputeIT
' Compute last result with current numeric entry
'   based on math function
'********************************************************
Sub ComputeIT
	'
	Select Case Session("NumberInFunction")
		Case ""
	   		Session("NumberIn") = CDbl(frm_NumIn)
		Case "+"
   			Session("NumberIn") = Session("NumberIn") + CDbl(frm_NumIn)
		Case "-"
   			Session("NumberIn") = Session("NumberIn") - CDbl(frm_NumIn)
		Case "x"
   			Session("NumberIn") = Session("NumberIn") * CDbl(frm_NumIn)
		Case "/"
   			Session("NumberIn") = Session("NumberIn") / CDbl(frm_NumIn)
	End Select

End Sub
%>


<html>

<head>

<style>
#t1 {color:green; font-size: 8pt; text-align: right;}
#t2 {color:red; font-size: 8pt; text-align: right;}
#btn {width:32; height:32;}
</style>

<title>myCalc</title>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<!--
<script type="text/javascript" src="Sys_web/Incl/jquery-latest.js">
</script>
-->
<script type="text/javascript">
        $(function() {
            $('#t1').scroll(function() {
            $('#t2')
                .scrollTop($('#t1').scrollTop());
            });
			$('#t2').scroll(function() {
            $('#t1')
                .scrollTop($('#t2').scrollTop());
            });
        });
    </script>

</head>

<body>

<!-- Calculator FORM -->
<form method="POST" action="<%=myScriptName%>" name="CalculateIT">
<!-- Place border on FORM and border title accordingly -->
<fieldset style="border-color:green; background-color:beige">
<legend style="color:blue; font-size: 18pt; background-color:lightsteelblue"><%=myTitle%></legend>
<!-- Audit Trail and Intermediate Result textboxes -->
<table align="center">
<tr>
<td align="center">Audit Trail</td>
<td align="center">Intermediate Results</td>
</tr>
<tr>
<td><textarea id="t1" rows="15" name="AuditTape" cols="30"  readonly="readonly"><%=frm_AuditTape%></textarea></td>
<td><textarea id="t2" rows="15" name="AccumTape" cols="50" readonly="readonly"><%=frm_AccumTape%></textarea></td>
</tr>
</table>

<!-- Script to scroll both result windows simultanously -->
<script type="text/javascript">
function Scroll_to_Bottom() 
{
document.getElementById('t1').scrollTop=document.getElementById('t1').scrollHeight;
document.getElementById('t2').scrollTop=document.getElementById('t2').scrollHeight;
}
//call the function
Scroll_to_Bottom ();
    </script>

<!-- Audit Trail and Intermediate Result textboxes -->
<br/> 
<table border="1" cellpadding="10" cellspacing="0" align="center" style="border-collapse: collapse ; background-color:DarkSeaGreen">
<tr>
<td>
<!-- Place border on keyboard and display components -->
<fieldset style="border-color:green; background-color:lightsteelblue">
<!-- Calculator Display Title -->
<%=MaxInput%> Digit Display
<br/>
<!-- Calculator Display -->
	<input name="NumIn" size="15" value="<%=frm_NumIn%>" style="text-align:right; font-size: 10pt" readonly="readonly">
<!-- Calculator Error Message area -->
<br/>
<font color=red size="2"><%=ErrMsg%></font>
<!-- Calculator Keypad -->
<br/>
      <input id="btn" type="submit" value="C"   name="Fclear" >&nbsp;
      <input id="btn" type="submit" value="CE"  name="Fcleare" >&nbsp;
      <input id="btn" type="submit" value="off" name="Poff" style="background-color: red; ">&nbsp;
      <input id="btn" type="submit" value="on"  name="Pon" style="background-color: green; color:lawngreen; ">&nbsp;
<br/>
      <input id="btn" type="submit" value="7"   name="B7" >&nbsp;
      <input id="btn" type="submit" value="8"   name="B8" >&nbsp;
      <input id="btn" type="submit" value="9"   name="B9" >&nbsp;
      <input id="btn" type="submit" value="/"   name="Fdiv" >&nbsp;
<br/>
      <input id="btn" type="submit" value="4"   name="B4" >&nbsp;
      <input id="btn" type="submit" value="5"   name="B5" >&nbsp;
      <input id="btn" type="submit" value="6"   name="B6" >&nbsp;
      <input id="btn" type="submit" value="x"   name="Fmult" >&nbsp;
<br/>
      <input id="btn" type="submit" value="1"   name="B1" >&nbsp;
      <input id="btn" type="submit" value="2"   name="B2" >&nbsp;
      <input id="btn" type="submit" value="3"   name="B3" >&nbsp;
      <input id="btn" type="submit" value="-"   name="Fminus" >&nbsp;
<br/>
      <input id="btn" type="submit" value="0"   name="B0" >&nbsp;
      <input id="btn" type="submit" value="."   name="Bdot" >&nbsp;
      <input id="btn" type="submit" value="="   name="Fequal" >&nbsp;
      <input id="btn" type="submit" value="+"   name="Fplus" >&nbsp;
</fieldset>
</td>
</tr>
</table>
</fieldset>
</form>
<u><i>myCalc</i></u> is for illustrative and educational purposes and does not represent a fully robust and tested calculator product.<br>
Copyright &copy; 2015 Larry Belmontes, Jr.
</body>

</html>